package com.jpattern.orm.annotation;

import java.lang.annotation.ElementType;
import java.lang.annotation.Inherited;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import com.jpattern.orm.session.Session;

/**
 * 
 * The {@link Cache} annotation identifies a bean that can be automatically cached by JPO
 * when a {@link Session#find(Class, Object)} method is called to get a Bean of this type.
 * If Bean has relations, the relations will be cached as well.
 * 
 * @author Francesco Cina
 *
 * 08/giu/2011
 */

@Target(value=ElementType.TYPE)
@Retention(value=RetentionPolicy.RUNTIME)
@Inherited
public @interface Cache {

    /**
     * The name of the cache to use.
     * @return
     */
    String cacheName() ;

}
