package com.jpattern.orm.annotation;

import java.lang.annotation.ElementType;
import java.lang.annotation.Inherited;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import com.jpattern.orm.annotation.cascade.CascadeType;

/**
 * 
 * Define a which action should be applied in cascade for that relation.
 * If the {@link Cascade} annotation is not used, the default behavior is that
 * all actions (delete, save, update) are applied on cascade to the related bean.
 * 
 * @author Francesco Cina
 *
 * 08/giu/2011
 */

@Target(value=ElementType.FIELD)
@Retention(value=RetentionPolicy.RUNTIME)
@Inherited
public @interface Cascade {

    CascadeType on();

}
