package com.jpattern.orm.annotation;

import java.lang.annotation.ElementType;
import java.lang.annotation.Inherited;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import com.jpattern.orm.annotation.fk.FKDefault;

/**
 * 
 * Define a dependency versus another Bean.
 * This can be used on a field to identify that its value is a foreign key versus another Bean
 * primary key. In the case the type of the relate Bean must be declared as value for the 'references'
 * parameter.
 * This annotation can also be used to identify a Bean field as a oneToOne relations.
 * 
 * @author Francesco Cina
 *
 * 08/giu/2011
 */

@Target(value=ElementType.FIELD)
@Retention(value=RetentionPolicy.RUNTIME)
@Inherited
public @interface FK {

    Class<?> references() default FKDefault.class;

}
