/* ----------------------------------------------------------------------------
 *     PROJECT : EURES
 *
 *     PACKAGE : com.jpattern.orm.annotation.cache
 *        FILE : CacheInfo.java
 *
 *  CREATED BY : ARHS Developments
 *          ON : Mar 10, 2013
 *
 * MODIFIED BY : ARHS Developments
 *          ON : $LastChangedDate
 *     VERSION : $LastChangedRevision
 *
 * ----------------------------------------------------------------------------
 * Copyright (c) 2011 European Commission - DG EMPL
 * ----------------------------------------------------------------------------
 */
package com.jpattern.orm.annotation.cache;

/**
 * <class_description>
 * <p><b>notes</b>:
 * <p>ON : Mar 10, 2013
 *
 * @author ARHS Developments - Francesco Cina
 * @version $Revision
 */
public interface CacheInfo {

    boolean isCacheable();

    String getCacheName();

    /**
     * It always returns the {@code defaultCache} if {@link #isCacheable()} is false
     * or {@code defaultCache} is not the empty {@link String}. Otherwise, cacheName is returned.
     * @param defaultCache
     * @return
     */
    String cacheToUse(String defaultCache);
}
