package com.jpattern.orm.annotation.cache;

import com.jpattern.orm.annotation.Cache;
import com.jpattern.orm.util.ObjectBuilder;

/**
 * 
 * @author cinafr
 *
 */
public class CacheInfoFactory {

    private CacheInfoFactory() {}

    public static CacheInfo getCacheInfo(final Class<?> clazz) {
        Cache cache = clazz.getAnnotation(Cache.class);
        if (cache!=null) {
            return new CacheInfoImpl(true, cache.cacheName());
        }
        return new CacheInfoImpl(false, ObjectBuilder.EMPTY_STRING);
    }

}
