/* ----------------------------------------------------------------------------
 *     PROJECT : EURES
 *
 *     PACKAGE : com.jpattern.orm.annotation.cache
 *        FILE : CacheInfoImpl.java
 *
 *  CREATED BY : ARHS Developments
 *          ON : Mar 10, 2013
 *
 * MODIFIED BY : ARHS Developments
 *          ON : $LastChangedDate
 *     VERSION : $LastChangedRevision
 *
 * ----------------------------------------------------------------------------
 * Copyright (c) 2011 European Commission - DG EMPL
 * ----------------------------------------------------------------------------
 */
package com.jpattern.orm.annotation.cache;

/**
 * <class_description>
 * <p><b>notes</b>:
 * <p>ON : Mar 10, 2013
 *
 * @author ARHS Developments - Francesco Cina
 * @version $Revision
 */
public class CacheInfoImpl implements CacheInfo {

    private final boolean cacheable;
    private final String cacheName;

    public CacheInfoImpl(final boolean cacheable, final String cacheName) {
        this.cacheable = cacheable;
        this.cacheName = cacheName;
    }

    @Override
    public boolean isCacheable() {
        return cacheable;
    }

    @Override
    public String getCacheName() {
        return cacheName;
    }

    @Override
    public String cacheToUse(final String defaultCache) {
        if (!cacheable || !defaultCache.isEmpty()) {
            return defaultCache;
        }
        return cacheName;
    }

}
