package com.jpattern.orm.annotation.cascade;

import java.lang.reflect.Field;

import com.jpattern.orm.annotation.Cascade;

/**
 * 
 * @author cinafr
 *
 */
public class CascadeInfoFactory {

    private CascadeInfoFactory() {}

    public static CascadeInfo getCascadeInfoInfo(final Field field) {
        Cascade cascade = field.getAnnotation(Cascade.class);
        if (cascade!=null) {
            return cascade.on().getInfo();
        }
        return CascadeType.ALWAYS.getInfo();
    }

}
