/* ----------------------------------------------------------------------------
 *     PROJECT : EURES
 *
 *     PACKAGE : com.jpattern.orm.annotation.cascade
 *        FILE : CascadeStrategyImpl.java
 *
 *  CREATED BY : ARHS Developments
 *          ON : Mar 10, 2013
 *
 * MODIFIED BY : ARHS Developments
 *          ON : $LastChangedDate
 *     VERSION : $LastChangedRevision
 *
 * ----------------------------------------------------------------------------
 * Copyright (c) 2011 European Commission - DG EMPL
 * ----------------------------------------------------------------------------
 */
package com.jpattern.orm.annotation.cascade;

/**
 * <class_description>
 * <p><b>notes</b>:
 * <p>ON : Mar 10, 2013
 *
 * @author ARHS Developments - Francesco Cina
 * @version $Revision
 */
public class CascadeInfoImpl implements CascadeInfo {

    private final boolean delete;
    private final boolean save;
    private final boolean update;

    public CascadeInfoImpl(final boolean delete, final boolean save, final boolean update) {
        this.delete = delete;
        this.save = save;
        this.update = update;

    }

    @Override
    public boolean onDelete() {
        return delete;
    }

    @Override
    public boolean onSave() {
        return save;
    }

    @Override
    public boolean onUpdate() {
        return update;
    }
}
