package com.jpattern.orm.annotation.generator;

import java.lang.reflect.Field;

import com.jpattern.orm.annotation.Generator;
import com.jpattern.orm.util.ObjectBuilder;

/**
 * 
 * @author cinafr
 *
 */
public class GeneratorInfoFactory {

    private GeneratorInfoFactory() {}

    public static GeneratorInfo getGeneratorInfo(final Field field) {
        Generator generator = field.getAnnotation(Generator.class);
        if (generator!=null) {
            return new GeneratorInfoImpl(generator.generatorType(), generator.name(), true);
        }
        return new GeneratorInfoImpl(GeneratorType.NONE, ObjectBuilder.EMPTY_STRING, false); 
    }

}
