package com.jpattern.orm.cache;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

/**
 * A simple cache based on {@link ConcurrentHashMap}.
 * @author Francesco Cina
 *
 * 23 Sep 2011
 */
public class SimpleCache extends ACache {

    private final Map<Object, Object> map = new ConcurrentHashMap<Object, Object>();

    @Override
    public Object getValue(final Object key) {
        return map.get(key);
    }

    @Override
    public void put(final Object key, final Object value) {
        map.put(key, value);
    }

    @Override
    public void remove(final Object key) {
        map.remove(key);
    }

    @Override
    public void clear() {
        map.clear();
    }

    @Override
    public boolean contains(final Object key) {
        return map.containsKey(key);
    }

}
