package com.jpattern.orm.cache.ehcache;

import net.sf.ehcache.Ehcache;
import net.sf.ehcache.Element;

import com.jpattern.orm.cache.ACache;

/**
 * 
 * @author Francesco Cina'
 *
 * 2 May 2011
 */
public class EhCache extends ACache {

    private final Ehcache ehcache;

    public EhCache(final Ehcache ehcache) {
        this.ehcache = ehcache;
    }

    @Override
    public Object getValue(final Object key) {
        Element element = ehcache.get(key);
        if (element != null) {
            return element.getValue();
        }
        return null;
    }

    @Override
    public void put(final Object key, final Object value) {
        ehcache.put(new Element(key, value));
    }

    @Override
    public void clear() {
        if (ehcache!=null) {
            ehcache.removeAll();
        }
    }

    @Override
    public void remove(final Object key) {
        if (ehcache!=null) {
            ehcache.remove(key);
        }
    }

    @Override
    public boolean contains(final Object key) {
        return ( (ehcache!=null) && (ehcache.get(key)!=null) );
    }

}
