package com.jpattern.orm.cache.ehcache;

import com.jpattern.orm.cache.Cache;
import com.jpattern.orm.cache.CacheManager;

/**
 * 
 * @author Francesco Cina'
 *
 * 2 May 2011
 */
public class EhCacheManager implements CacheManager {

    private final net.sf.ehcache.CacheManager cacheManager;

    public EhCacheManager(final net.sf.ehcache.CacheManager cacheManager) {
        this.cacheManager = cacheManager;
    }

    @Override
    public Cache getCache(final String cacheName) {
        return new EhCache(cacheManager.getEhcache(cacheName));
    }

    @Override
    public void stopCacheManager() {
        cacheManager.shutdown();
    }

}
