package com.jpattern.orm.dialect;

/**
 * 
 * @author Francesco Cina
 *
 * 28/giu/2011
 * 
 * This is the default {@link DBProfile} used by the orm.
 * It is supposed that the unknown DB supports all the needed features.
 */
public class UnknownDBProfile implements DBProfile {

    @Override
    public String insertQuerySequence(final String name) {
        return name + ".nextval"; //$NON-NLS-1$
    }

    @Override
    public boolean isSequenceSupport() {
        return true;
    }

    @Override
    public boolean isAutogeneratedKeySupport() {
        return true;
    }

}
