/* ----------------------------------------------------------------------------
 *     PROJECT : JPOrm
 *
 *  CREATED BY : Francesco Cina'
 *          ON : Feb 28, 2013
 * ----------------------------------------------------------------------------
 */
package com.jpattern.orm.mapper;

import com.jpattern.orm.annotation.cache.CacheInfoImpl;
import com.jpattern.orm.annotation.table.TableInfo;
import com.jpattern.orm.mapper.clazz.ClassMapImpl;
import com.jpattern.orm.mapper.clazz.ClassMap;
import com.jpattern.orm.persistor.OrmPersistor;
import com.jpattern.orm.util.ObjectBuilder;

/**
 * <class_description>
 * <p><b>notes</b>:
 * <p>ON : Feb 28, 2013
 *
 * @author Francesco Cina'
 * @version $Revision
 */
public class NullOrmClassTool<T> implements OrmClassTool<T> {

    @Override
    public ClassMap<T> getClassMap() {
        return new ClassMapImpl<T>(null, new TableInfo(ObjectBuilder.EMPTY_STRING, ObjectBuilder.EMPTY_STRING), new CacheInfoImpl(false, ObjectBuilder.EMPTY_STRING));  
    }

    @Override
    public OrmPersistor<T> getOrmPersistor() {
        return null;
    }

}
