package com.jpattern.orm.mapper;

import com.jpattern.orm.mapper.clazz.ClassMap;
import com.jpattern.orm.persistor.OrmPersistor;


/**
 * 
 * @author Francesco Cina
 *
 * 22/mag/2011
 */
public class OrmClassToolImpl<BEAN> implements OrmClassTool<BEAN> {

    private final ClassMap<BEAN> classMapper;
    private final OrmPersistor<BEAN> ormPersistor;

    public OrmClassToolImpl(final ClassMap<BEAN> classMapper, final OrmPersistor<BEAN> ormPersistor) {
        this.classMapper = classMapper;
        this.ormPersistor = ormPersistor;
    }

    @Override
    public ClassMap<BEAN> getClassMap() {
        return this.classMapper;
    }

    @Override
    public OrmPersistor<BEAN> getOrmPersistor() {
        return this.ormPersistor;
    }

}
