package com.jpattern.orm.mapper;

import com.jpattern.orm.cache.CacheManager;
import com.jpattern.orm.dialect.DBProfile;
import com.jpattern.orm.exception.OrmException;
import com.jpattern.orm.persistor.type.TypeFactory;
import com.jpattern.orm.query.find.cache.CacheStrategy;
import com.jpattern.orm.query.namesolver.PropertiesFactory;
import com.jpattern.orm.validator.ValidatorService;

/**
 * 
 * @author Francesco Cina
 *
 * 22/mag/2011
 * 
 */
public interface ServiceCatalog {

    boolean containsTool(Class<?> clazz);

    <T> OrmClassTool<T> getOrmClassTool(Class<T> clazz) throws OrmException;

    TypeFactory getTypeFactory();

    DBProfile getDbProfile();

    ValidatorService getValidatorService();

    CacheManager getCacheManager();

    CacheStrategy getCacheStrategy();

    PropertiesFactory getPropertiesFactory();

}
