package com.jpattern.orm.persistor;

import java.sql.ResultSet;
import java.util.List;

/**
 * @author Francesco Cina
 *
 * 22/mag/2011
 * 
 */
public interface OrmPersistor<BEAN>  {

    BeanFromResultSet<BEAN> beanFromResultSet(ResultSet rs, List<String> fieldsToIgnore);

    BEAN clone(BEAN entity);

    /**
     * @param propertyNames
     * @param propertyValues
     * @return
     */
    BEAN newInstance();

    boolean isVersionable();

    void increaseVersion(BEAN entity, boolean firstVersionNumber);

    /**
     * Return whether in the save query there are automatically
     * generated key (for example using a call to a Sequence in the
     * insert query)
     * @return
     */
    boolean useGenerators(BEAN entity);

    void updateGeneratedValues(ResultSet rs, BEAN entity);

    boolean hasGenerator();

    /**
     * @param javaColumnNames
     * @param entity
     * @return
     */
    Object[] getPropertyValues(String[] javaColumnNames, BEAN entity);

}
