package com.jpattern.orm.persistor.generator;

import java.lang.reflect.InvocationTargetException;

import com.jpattern.orm.persistor.PropertyPersistor;

/**
 * 
 * @author Francesco Cina'
 *
 * Apr 1, 2012
 */
public class GeneratorManipulatorImpl<BEAN, P> extends GeneratorManipulator<BEAN> {

    private final PropertyPersistor<BEAN, P, ?> fieldManipulator;
    private final ValueChecker<P> valueChecker;

    public GeneratorManipulatorImpl(final PropertyPersistor<BEAN, P, ?> fieldManipulator) throws SecurityException {
        this.fieldManipulator = fieldManipulator;
        valueChecker = ValueCheckerFactory.getValueChecker(fieldManipulator.propertyType());
    }

    @Override
    public  boolean useGenerator(final BEAN bean) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
        return valueChecker.useGenerator( this.fieldManipulator.getPropertyValueFromBean(bean) );
    }

    @Override
    public boolean hasGenerator() {
        return true;
    }

}
