package com.jpattern.orm.query.clause.from;

import com.jpattern.orm.mapper.ServiceCatalog;

/**
 * 
 * @author Francesco Cina
 *
 * 27/giu/2011
 */
public class RightOuterJoinElement extends AFromElement {

    private final String onLeftProperty;
    private final String onRigthProperty;
    private boolean onClause = true;

    public RightOuterJoinElement(final ServiceCatalog serviceCatalog, final Class<?> joinClass, final Integer nameSolverClassId) {
        this(serviceCatalog, joinClass, nameSolverClassId, "", ""); //$NON-NLS-1$ //$NON-NLS-2$
        onClause = false;
    }

    public RightOuterJoinElement(final ServiceCatalog serviceCatalog, final Class<?> joinClass, final Integer nameSolverClassId, final String onLeftProperty, final String onRigthProperty) {
        super(serviceCatalog, joinClass, nameSolverClassId);
        this.onLeftProperty = onLeftProperty;
        this.onRigthProperty = onRigthProperty;
    }

    @Override
    protected String getJoinName() {
        return "RIGHT OUTER JOIN "; //$NON-NLS-1$
    }

    @Override
    protected boolean hasOnClause() {
        return onClause ;
    }

    @Override
    protected String onLeftProperty() {
        return onLeftProperty;
    }

    @Override
    protected String onRightProperty() {
        return onRigthProperty;
    }

}
