package com.jpattern.orm.query.clause.order;

import java.util.List;

import com.jpattern.orm.query.SmartRenderableSqlSubElement;
import com.jpattern.orm.query.namesolver.NameSolver;

/**
 * 
 * @author Francesco Cina
 *
 * 24/giu/2011
 */
public class OrmOrderElement extends SmartRenderableSqlSubElement implements OrderElement {

    private final boolean isFirstElement;
    private final OrderByType type;
    private final String property;

    public OrmOrderElement(final String property, final boolean isFirstElement, final OrderByType type) {
        this.property = property;
        this.isFirstElement = isFirstElement;
        this.type = type;
    }

    @Override
    public final int getElementStatusVersion() {
        return 0;
    }

    @Override
    public final void doElementRender(final StringBuilder queryBuilder, final NameSolver nameSolver) {
        if (!isFirstElement) {
            queryBuilder.append( ", " ); //$NON-NLS-1$
        }
        queryBuilder.append( nameSolver.solvePropertyName(property) );
        queryBuilder.append( " " ); //$NON-NLS-1$
        queryBuilder.append( type.getType() );
        queryBuilder.append( type.getNulls() );
    }

    @Override
    public final void appendElementValues(final List<Object> values) {
        // do nothing
    }

}
