package com.jpattern.orm.query.clause.where;

import java.util.List;

import com.jpattern.orm.exception.OrmQueryFormatException;
import com.jpattern.orm.query.SmartRenderableSqlSubElement;
import com.jpattern.orm.query.namesolver.NameSolver;

/**
 * 
 * @author Francesco Cina
 *
 * 26/giu/2011
 */
public class NotExpressionElement extends SmartRenderableSqlSubElement implements ExpressionElement {

    protected final ExpressionElement expression;

    public NotExpressionElement(final ExpressionElement expression) {
        this.expression = expression;
    }

    @Override
    public final void doElementRender(final StringBuilder query, final NameSolver nameSolver) throws OrmQueryFormatException {
        query.append("NOT ( "); //$NON-NLS-1$
        expression.renderSqlElement(query, nameSolver);
        query.append(") "); //$NON-NLS-1$
    }

    @Override
    public final void appendElementValues(final List<Object> values) {
        expression.appendElementValues(values);
    }

    @Override
    public final int getElementStatusVersion() {
        return 0;
    }

}