package com.jpattern.orm.query.clause.where;

import java.util.List;

import com.jpattern.orm.query.BaseFindQuery;
import com.jpattern.orm.query.SmartRenderableSqlSubElement;
import com.jpattern.orm.query.namesolver.NameSolver;

/**
 * 
 * @author ufo
 *
 */
public abstract class SubQueryExpressionElement extends SmartRenderableSqlSubElement implements ExpressionElement {

    private final BaseFindQuery query;
    private final String property;
    private final String condition;

    public SubQueryExpressionElement(final String property, final BaseFindQuery query, final String condition) {
        this.property = property;
        this.query = query;
        this.condition = condition;
    }

    @Override
    public final void doElementRender(final StringBuilder queryBuilder, final NameSolver nameSolver) {
        queryBuilder.append(  nameSolver.solvePropertyName( property ) );
        queryBuilder.append( condition );
        queryBuilder.append( "( "); //$NON-NLS-1$
        query.renderSql(queryBuilder);
        queryBuilder.append(") "); //$NON-NLS-1$
    }

    @Override
    public final void appendElementValues(final List<Object> values) {
        query.appendValues(values);
    }

    @Override
    public final int getElementStatusVersion() {
        return 0;
    }
}
