/* ----------------------------------------------------------------------------
 *     PROJECT : JPOrm
 *
 *  CREATED BY : Francesco Cina'
 *          ON : Feb 25, 2013
 * ----------------------------------------------------------------------------
 */
package com.jpattern.orm.query.crud;

import com.jpattern.orm.util.ObjectBuilder;

/**
 * <class_description>
 * <p><b>notes</b>:
 * <p>ON : Feb 25, 2013
 *
 * @author Francesco Cina'
 * @version $Revision
 */
public abstract class AFind<BEAN> implements Find<BEAN> {

    private boolean _lazy = false;
    private String cache = ObjectBuilder.EMPTY_STRING;
    private String[] _ignoredFields = ObjectBuilder.EMPTY_STRING_ARRAY;

    @Override
    public final Find<BEAN> lazy(final boolean lazy) {
        this._lazy = lazy;
        return this;
    }

    public boolean isLazy() {
        return _lazy;
    }

    protected String getCache() {
        return cache;
    }

    @Override
    public final Find<BEAN> cache(final String cacheName) {
        this.cache = cacheName;
        return this;
    }

    @Override
    public final Find<BEAN> ignore(final String... fields) {
        return ignore(true, fields);
    }

    @Override
    public final Find<BEAN> ignore(final boolean excludeFieldsCondition, final String... fields) {
        if(excludeFieldsCondition) {
            _ignoredFields = fields;
        }
        return this;
    }

    /**
     * @return the _ecludeFields
     */
    public String[] getIgnoredFields() {
        return _ignoredFields;
    }

}
