package com.jpattern.orm.query.find;

import com.jpattern.orm.exception.OrmException;
import com.jpattern.orm.mapper.ServiceCatalog;
import com.jpattern.orm.query.clause.OrmFrom;
import com.jpattern.orm.query.namesolver.NameSolver;

/**
 * 
 * @author ufo
 *
 * @param <BEAN>
 */
public class FindFromImpl<BEAN> extends OrmFrom<FindQuery<BEAN>> implements FindFrom<BEAN> {

    private final FindQuery<BEAN> findQuery;

    public FindFromImpl(final FindQuery<BEAN> findQuery, final ServiceCatalog serviceCatalog, final Class<?> clazz, final Integer nameSolverClassId, final NameSolver nameSolver)  {
        super(serviceCatalog, clazz, nameSolverClassId, nameSolver);
        this.findQuery = findQuery;
    }

    @Override
    protected FindQuery<BEAN> from() throws OrmException {
        return this.findQuery;
    }

}
