package com.jpattern.orm.query.namesolver;

import com.jpattern.orm.exception.OrmException;

/**
 * 
 * @author Francesco Cina
 *
 * 19/giu/2011
 */
public interface NameSolver  {

    /**
     * Resolve a property in a query to his name in the database using the table alias as prefix.
     * @param property
     * @return
     */
    String solvePropertyName(String property) throws OrmException;

    /**
     * Register a class and use the passed alias parameter as alias to resolve the property name.
     * @param clazz
     * @param alias
     * @return the registered class id
     */
    <P> Integer register(Class<P> clazz, String alias) throws OrmException;

    /**
     * Return the alias of a registered class
     * @param clazz
     * @return
     * @throws OrmException
     */
    String normalizedAlias(Integer clazzId) throws OrmException;

}
