package com.jpattern.orm.query.save;

import java.util.Map;

import com.jpattern.orm.query.QueryRoot;
import com.jpattern.orm.query.saveorupdate.SaveOrUpdateType;


/**
 * 
 * @author Francesco Cina
 *
 * 10/lug/2011
 */
public interface SaveQuery<BEAN> extends QueryRoot {

    /**
     * @return
     */
    SaveQuery<BEAN> value(String propertyName, Object value);

    /**
     * Perform the update and return the number of affected rows.
     * @return
     */
    BEAN now();

    /**
     * Set the query timeout for the query.
     */
    SaveQuery<BEAN> setQueryTimeout(int queryTimeout);

    /**
     * Return the query timeout for the query.
     */
    int getQueryTimeout();

    /**
     * @param properties
     * @return
     */
    SaveQuery<BEAN> values(Map<String, Object> properties);

    /**
     * Whether to save the children recursively. Default is false.
     * @param cascade
     * @return
     */
    SaveQuery<BEAN> cascade(boolean cascade);

    /**
     * @param saveOrUpdate
     * @return
     */
    SaveQuery<BEAN> saveOrUpdate(final SaveOrUpdateType saveOrUpdateType);
}
