package com.jpattern.orm.query.sql;

import com.jpattern.orm.session.GeneratedKeyReader;
import com.jpattern.orm.session.SessionImpl;
import com.jpattern.orm.session.SqlPerformer;

/**
 * 
 * @author Francesco Cina
 *
 * 09/lug/2011
 */
public class PlainGKReaderSqlUpdateQuery implements SqlUpdateQuery {

    private int queryTimeout = 0;
    private final SessionImpl session;
    private final String sql;
    private final GeneratedKeyReader generatedKeyReader;
    private final Object[] args;

    public PlainGKReaderSqlUpdateQuery(final SessionImpl session, final String sql, final GeneratedKeyReader generatedKeyReader, final Object[] args) {
        this.session = session;
        this.sql = sql;
        this.generatedKeyReader = generatedKeyReader;
        this.args = args;
    }

    @Override
    public void execute() {
        update();
    }

    @Override
    public void setQueryTimeout(final int queryTimeout) {
        this.queryTimeout  = queryTimeout;
    }

    @Override
    public int getQueryTimeout() {
        return queryTimeout;
    }

    @Override
    public int update() {
        SqlPerformer sqlExec = session.sqlPerformer();
        sqlExec.setQueryTimeout(getQueryTimeout());
        return sqlExec.update(sql , generatedKeyReader, args);
    }

}
