package com.jpattern.orm.query.sql;

import java.util.List;

import com.jpattern.orm.session.SessionImpl;
import com.jpattern.orm.session.SqlPerformer;

/**
 * 
 * @author Francesco Cina
 *
 * 09/lug/2011
 */
public class PlainSqlBatchUpdateQuery implements SqlBatchUpdateQuery {

    private int queryTimeout = 0;
    private final SessionImpl session;
    private final String sql;
    private final List<Object[]> args;

    public PlainSqlBatchUpdateQuery(final SessionImpl session, final String sql, final List<Object[]> args) {
        this.session = session;
        this.sql = sql;
        this.args = args;
    }

    @Override
    public void execute() {
        update();
    }

    @Override
    public void setQueryTimeout(final int queryTimeout) {
        this.queryTimeout  = queryTimeout;
    }

    @Override
    public int getQueryTimeout() {
        return queryTimeout;
    }

    @Override
    public int[] update() {
        SqlPerformer sqlExec = session.sqlPerformer();
        sqlExec.setQueryTimeout(getQueryTimeout());
        return sqlExec.batchUpdate(sql , args);
    }

}
