package com.jpattern.orm.query.sql;

import com.jpattern.orm.session.SessionImpl;
import com.jpattern.orm.session.SqlPerformer;

/**
 * 
 * @author Francesco Cina
 *
 * 09/lug/2011
 */
public class PlainSqlExecuteQuery implements SqlExecuteQuery {

    private int queryTimeout = 0;
    private final SessionImpl session;
    private final String sql;

    public PlainSqlExecuteQuery(final SessionImpl session, final String sql) {
        this.session = session;
        this.sql = sql;
    }

    @Override
    public void execute() {
        SqlPerformer sqlExec = session.sqlPerformer();
        sqlExec.setQueryTimeout(getQueryTimeout());
        sqlExec.execute(sql);
    }

    @Override
    public void setQueryTimeout(final int queryTimeout) {
        this.queryTimeout = queryTimeout;
    }

    @Override
    public int getQueryTimeout() {
        return queryTimeout;
    }

}
