package com.jpattern.orm.query.sql;

import java.util.List;

import com.jpattern.orm.session.SessionImpl;
import com.jpattern.orm.session.SqlPerformer;

/**
 * 
 * @author Francesco Cina
 *
 * 09/lug/2011
 */
public class PlainSqlListBatchUpdateQuery implements SqlBatchUpdateQuery {

    private int queryTimeout = 0;
    private final SessionImpl session;
    private final List<String> sqls;

    public PlainSqlListBatchUpdateQuery(final SessionImpl session, final List<String> sqls) {
        this.session = session;
        this.sqls = sqls;
    }

    @Override
    public void execute() {
        update();
    }

    @Override
    public void setQueryTimeout(final int queryTimeout) {
        this.queryTimeout = queryTimeout;
    }

    @Override
    public int getQueryTimeout() {
        return queryTimeout ;
    }

    @Override
    public int[] update() {
        SqlPerformer sqlExec = session.sqlPerformer();
        sqlExec.setQueryTimeout(getQueryTimeout());
        return sqlExec.batchUpdate(sqls);
    }

}
