package com.jpattern.orm.query.update;

import java.util.List;

import com.jpattern.orm.query.clause.OrmSet;

/**
 * 
 * @author ufo
 *
 */
public class CustomUpdateSetImpl extends OrmSet<CustomUpdateSet> implements CustomUpdateSet {

    private final CustomUpdateQuery query;

    public CustomUpdateSetImpl(final CustomUpdateQuery query) {
        this.query = query;
    }

    @Override
    public String renderSql() {
        return query.renderSql();
    }

    @Override
    public void renderSql(final StringBuilder stringBuilder) {
        query.renderSql(stringBuilder);
    }

    @Override
    public void appendValues(final List<Object> values) {
        query.appendValues(values);
    }

    @Override
    public final int now() {
        return query.now();
    }

    @Override
    public CustomUpdateQuery query() {
        return query;
    }

    @Override
    protected CustomUpdateSet set() {
        return this;
    }

    @Override
    public CustomUpdateWhere where() {
        return query.where();
    }

    @Override
    public CustomUpdateQuery queryTimeout(final int queryTimeout) {
        return query.queryTimeout(queryTimeout);
    }

}
