package com.jpattern.orm.session;

import javax.sql.DataSource;

import com.jpattern.orm.exception.OrmException;
import com.jpattern.orm.transaction.NullTransaction;
import com.jpattern.orm.transaction.Transaction;
import com.jpattern.orm.transaction.TransactionDefinition;

/**
 * 
 * @author Francesco Cina
 *
 * 24/giu/2011
 */
public class NullSessionProvider extends SessionProvider {

    @Override
    public DataSource getDataSource() {
        return null;
    }

    @Override
    public Transaction getTransaction(
            final TransactionDefinition transactionDefinition) throws OrmException {
        return new NullTransaction();
    }

    @Override
    public SqlPerformerStrategy sqlPerformerStrategy() throws OrmException {
        return new NullSqlPerformerStrategy();
    }

}
