package com.jpattern.orm.session.datasource;

import java.sql.PreparedStatement;

import com.jpattern.orm.exception.OrmException;

/**
 * 
 * <class_description>
 * <p><b>notes</b>:
 * <p>ON : Mar 9, 2013
 *
 * @author ARHS Developments - Francesco Cina
 * @version $Revision
 */
public interface DataSourceConnection {

    boolean isValid() throws OrmException;

    void setTransactionIsolation(int transactionIsolation) throws OrmException;

    boolean isClosed() throws OrmException;

    void rollback() throws OrmException;

    void commit() throws OrmException;

    PreparedStatement prepareStatement(String sql) throws OrmException;

    PreparedStatement prepareStatement(String sql, String[] generatedColumnNames) throws OrmException;

    DataSourceStatement createStatement() throws OrmException;

    void addCaller(DataSourceConnectionCaller connectionCaller) throws OrmException;

    void close(DataSourceConnectionCaller connectionCaller) throws OrmException;

    void setRollbackOnly() throws OrmException;

    void setReadOnly(boolean readOnly) throws OrmException;

    boolean isRollbackOnly();

}
