/* ----------------------------------------------------------------------------
 *     PROJECT : EURES
 *
 *     PACKAGE : com.jpattern.orm.util
 *        FILE : ObjectBuilder.java
 *
 *  CREATED BY : ARHS Developments
 *          ON : Mar 9, 2013
 *
 * MODIFIED BY : ARHS Developments
 *          ON : $LastChangedDate
 *     VERSION : $LastChangedRevision
 *
 * ----------------------------------------------------------------------------
 * Copyright (c) 2011 European Commission - DG EMPL
 * ----------------------------------------------------------------------------
 */
package com.jpattern.orm.util;

import java.util.Collections;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * <class_description>
 * <p><b>notes</b>:
 * <p>ON : Mar 9, 2013
 *
 * @author ARHS Developments - Francesco Cina
 * @version $Revision
 */
public class ObjectBuilder {

    private ObjectBuilder() {}

    public static final String[] EMPTY_STRING_ARRAY = new String[0];
    public static final String EMPTY_STRING = ""; //$NON-NLS-1$
    public static final List<String> EMPTY_STRING_LIST = Collections.EMPTY_LIST;

    public static <KEY, VALUE> Map<KEY, VALUE> newMaxSizeMap(final int maxSize) {
        return new LinkedHashMap<KEY, VALUE>() {
            private static final long serialVersionUID = 1L;
            @Override
            protected boolean removeEldestEntry(final Map.Entry<KEY, VALUE> eldest) {
                return size() > maxSize;
            }
        };
    }

}
