package com.jpattern.orm.validator.jsr303;

import java.util.Set;

import javax.validation.ConstraintViolation;
import javax.validation.ConstraintViolationException;

import com.jpattern.orm.validator.Validator;

/**
 * 
 * @author ufo
 *
 * @param <T>
 */
public class JSR303Validator<T> implements Validator<T> {

    private final T data;
    private final javax.validation.Validator validator;

    public JSR303Validator(final T data, final javax.validation.Validator validator) {
        this.data = data;
        this.validator = validator;
    }

    @Override
    @SuppressWarnings({ "rawtypes", "unchecked" })
    public void validateThrowException() {
        Set<ConstraintViolation<T>> validationResult = this.validator.validate(this.data);
        if (!validationResult.isEmpty()) {
            throw new ConstraintViolationException((Set) validationResult);
        }
    }

}
